<template>
  <v-container fluid>
    <v-data-iterator
      :items="items"
      :items-per-page.sync="itemsPerPage"
      :page.sync="page"
      :search="search"
      hide-default-footer
    >
      <template v-slot:header>
        <Stockout />

        <NeedtoOrder />

        <br /><br />

        <v-toolbar color="#52734D" class="mb-1" width="600px" height="75px" dark>
          <v-icon>mdi-shopping-search-outline</v-icon>
          <h1>Available Product</h1>
          <v-spacer></v-spacer>
          <v-text-field
            v-model="search"
            clearable
            flat
            solo-inverted
            hide-details
            prepend-inner-icon="mdi-magnify"
            label="Search"
          ></v-text-field>
        </v-toolbar>
      </template>

      <template v-slot:default="props">
        <v-row>
          <v-col
            v-for="item in props.items"
            :key="item.name"
            cols="12"
            sm="6"
            md="4"
            lg="3"
          >
            <v-card color="#B6E2A1">
              <v-card-title class="subheading font-weight-bold">
                {{ item.name }}
              </v-card-title>

              <v-divider></v-divider>

              <v-list dense>
                <v-list-item v-for="(key, index) in filteredKeys" :key="index">
                  <v-list-item-content
                    :class="{ 'blue--text': sortBy === key }"
                  >
                    {{ key }}:
                  </v-list-item-content>
                  <v-list-item-content
                    class="align-end"
                    :class="{ 'blue--text': sortBy === key }"
                  >
                    {{ item[key.toLowerCase()] }}
                  </v-list-item-content>
                </v-list-item>
              </v-list>
            </v-card>
          </v-col>
        </v-row>
      </template>

      <template v-slot:footer>
        <v-row class="mt-2" align="center" justify="center">
          <v-spacer></v-spacer>
          <v-spacer></v-spacer>

          <span class="mr-4 grey--text">
            Page {{ page }} of {{ numberOfPages }}
          </span>
          <v-btn
            fab
            dark
            color="#52734D"
            class="mr-1"
            @click="formerPage"
          >
            <v-icon>mdi-chevron-left</v-icon>
          </v-btn>
          <v-btn fab dark color="#52734D" class="ml-1" @click="nextPage">
            <v-icon>mdi-chevron-right</v-icon>
          </v-btn>
        </v-row>
      </template>
    </v-data-iterator>
  </v-container>
</template>

<script>
import { right } from "inquirer/lib/utils/readline";
import Editstock from "~/components/editstock.vue";
import Stockout from "~/components/Stockout.vue";

export default {
  layout:'default4',
  data() {
    return {
      itemsPerPageArray: [12],
      search: "",
      filter: {},
      page: 1,
      itemsPerPage: 12,
      sortBy: "name",
      keys: ["Name", "Available"],
      items: [
        {
          name: "Normal Coffee",
          available: 100,
        },
        {
          name: "Cocoa",
          available: 100,
        },
        {
          name: "Plastic Cup",
          available: 100,
        },
        {
          name: "Plastic Covercup",
          available: 100,
        },
        {
          name: "Straw",
          available: 100,
        },
        {
          name: "Plastic Bag",
          available: 100,
        },
        {
          name: "Paper",
          available: 100,
        },
      ],
    };
  },
  computed: {
    numberOfPages() {
      return Math.ceil(this.items.length / this.itemsPerPage);
    },
    filteredKeys() {
      return this.keys.filter((key) => key !== "Name");
    },
  },
  methods: {
    nextPage() {
      if (this.page + 1 <= this.numberOfPages) this.page += 1;
    },
    formerPage() {
      if (this.page - 1 >= 1) this.page -= 1;
    },
    updateItemsPerPage(number) {
      this.itemsPerPage = number;
    },
    edit() {
      this.$router.push({ name: "../components/editstock" });
    },
  },
  components: { Stockout, Editstock, right },
};
</script>